# Visa Consent Management Service
The Visa Consent Management Service (VCMS) is a solution that enables informed and explicit consumer consent experience. This helps Visa and our clients in collecting user consent in a consistent, transparent, and intuitive manner.

## Version: 1

### Servers

| URL | Description |
| --- | ----------- |
| https://sandbox.api.visa.com | Sandbox server |

---
## Visa Consent Management API
Visa Consent Management API

### [POST] /vcms/v1/consents/{consentID}/revoke
**Revoke Consent**

This API revokes a current consent.
A consent may be revoked if it is in either ACTIVE or PAUSED state. Attempting to revoke a consent in any other state results in a 409 error with <code>invalidConsentStateTransition</code> reason.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| consentID | path | Consent identifier.  | Yes | string | No |

#### Request Body

Request body for revocation payload.

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"revocationReason"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Updated consent. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"status"**: string, <br>**Available values:** "INITIATED", "ACTIVE", "REVOKED", "EXPIRED", "CONSUMED", "PAUSED", **"userID"**: string, **"consentID"**: string (uuid) } & { **"frequency"**: string, <br>**Available values:** "STREAMING", "PERIODIC", "ON_DEMAND", "CONTEXT_BASED", <br>**Default:** STREAMING, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"primaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"externalConsentID"**: string, **"presentedLanguage"**: string (BCP-47), **"previousConsentID"**: string (uuid), **"secondaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"consentCaptureCity"**: string, **"consentDirectoryID"**: string (uuid), **"expirationDateTime"**: string (RFC3339), **"privacyPolicyVersion"**: string, **"consentCaptureCountry"**: string (ISO 3166-1 alpha 2), **"consentCaptureDateTime"**: string (RFC3339), **"presentedContentVersion"**: string, **"presenterOrganizationID"**: string (uuid), **"consentCaptureRegionState"**: string (ISO 3166-2 subdivision), **"resourceProviderOrganizationIDs"**: [ string (uuid) ] } & { **"constraints"**: { **"timespan"**: { **"endDateTime"**: string (RFC3339), **"startDateTime"**: string (RFC3339) }, **"maxNumberUses"**: integer, **"remainingNumberUses"**: integer }, **"createdDateTime"**: string (RFC3339), **"updatedDateTime"**: string (RFC3339), **"financialInstruments"**: [ { **"instrumentID"**: string (uuid), **"accountNumber"**: string, **"instrumentType"**: string, <br>**Available values:** "PAYMENT_CARD", "VCARDID", "BANK_ACCOUNT", "PAYMENT_TOKEN" } ], **"consumerContactInformation"**: { **"phoneNumber"**: string, **"emailAddress"**: string (Email Address), **"isPhoneNumberVerified"**: boolean, **"isEmailAddressVerified"**: boolean }, **"identityVerificationDetails"**: { **"userID"**: string, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"attestation"**: string, **"attestationType"**: string, <br>**Available values:** "ID_TOKEN" } }<br> |
| 400 | The <code>details</code> part of the error response can provide a list of fields that failed data validation constraints and reason values for this error include:   <ul>   <li><code>badRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that this Visa Developer Center project does not have permission to access the requested resource. This can happen if you are trying to invoke an API request for a resource that is not part of your project.  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 404 | The specified resource was not found<br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable. This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 409 | The current state of consent is incompatible with the requested mutation. For example, an EXPIRED consent cannot be revoked.</li> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |

### [PUT] /vcms/v1/consents/{consentID}/constraints/remainingNumberUses
**Update Remaining Consent Uses**

API for Visa partners (Consent Requestors) to update the remaining number of uses for a multi-use consent.
Notes:
+ This API is idempotent.
+ For an active consent, this value may be set to less than or equal to the current value, and only if maxNumberUses is set as non-zero on the consent. Any violation of the above conditions will result in a 409 error with <code>invalidConsentModification</code> reason. If set to zero, the status of the consent changes to CONSUMED and is no longer active.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| consentID | path | Consent identifier.  | Yes | string | No |

#### Request Body

Consent request body for PUT remaining number of uses.

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"remainingNumberUses"**: integer }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Consent remainingNumberUses updated successfully <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"remainingNumberUses"**: integer }<br> |
| 400 | The <code>details</code> part of the error response can provide a list of fields that failed data validation constraints and reason values for this error include:   <ul>   <li><code>badRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that this Visa Developer Center project does not have permission to access the requested resource. This can happen if you are trying to invoke an API request for a resource that is not part of your project.  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 404 | The specified resource was not found<br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable. This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 409 | The current state of consent is incompatible with the requested mutation. For example, an EXPIRED consent cannot be revoked.</li> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |

### [POST] /vcms/v1/consents
**Save Consent**

API for Visa partners (Consent Requestors) to save a consumer-granted consent.
Notes:
+ This API is not idempotent, and there is no duplicate check to prevent clients from creating multiple consents with the same values.
+ The associated Consent Directory entry determines which, if any, identity verification attestation is required.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Request Body

Consent request body for transaction data.

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"userID"**: string } & { **"frequency"**: string, <br>**Available values:** "STREAMING", "PERIODIC", "ON_DEMAND", "CONTEXT_BASED", <br>**Default:** STREAMING, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"primaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"externalConsentID"**: string, **"presentedLanguage"**: string (BCP-47), **"previousConsentID"**: string (uuid), **"secondaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"consentCaptureCity"**: string, **"consentDirectoryID"**: string (uuid), **"expirationDateTime"**: string (RFC3339), **"privacyPolicyVersion"**: string, **"consentCaptureCountry"**: string (ISO 3166-1 alpha 2), **"consentCaptureDateTime"**: string (RFC3339), **"presentedContentVersion"**: string, **"presenterOrganizationID"**: string (uuid), **"consentCaptureRegionState"**: string (ISO 3166-2 subdivision), **"resourceProviderOrganizationIDs"**: [ string (uuid) ] } & { **"constraints"**: { **"timespan"**: { **"endDateTime"**: string (RFC3339), **"startDateTime"**: string (RFC3339) }, **"maxNumberUses"**: integer }, **"financialInstruments"**: [ { **"accountNumber"**: string, **"instrumentType"**: string, <br>**Available values:** "PAYMENT_CARD", "VCARDID", "BANK_ACCOUNT", "PAYMENT_TOKEN" } ], **"consumerContactInformation"**: { **"phoneNumber"**: string, **"emailAddress"**: string (Email Address), **"isPhoneNumberVerified"**: boolean, **"isEmailAddressVerified"**: boolean }, **"identityVerificationDetails"**: { **"userID"**: string, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"attestation"**: string, **"attestationType"**: string, <br>**Available values:** "ID_TOKEN", "THREED_SECURE" } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Consent granted (object created) successfully<br>**Headers:**<br>**Location**: Location<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> |  |
| 400 | The <code>details</code> part of the error response can provide a list of fields that failed data validation constraints and reason values for this error include:   <ul>   <li><code>badRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that this Visa Developer Center project does not have permission to access the requested resource. This can happen if you are trying to invoke an API request for a resource that is not part of your project.  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable. This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 409 | The current state of consent is incompatible with the requested mutation. For example, an EXPIRED consent cannot be revoked.</li> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |

#### Callback: consentCreated

##### [POST] `{callbackURL}`
**Consent Created Callback**

These are API calls initiated by the Visa Consent System to the Visa Partner’s backend servers.
+ The <code>callbackURL</code> is specified by the Visa partners during onboarding.
+ Invoked whenever a consent is created. The if details of the consent are required, the message recipient must fetch the consent details using the GET /consents/{consentId} API.
+ There will be 2 retries with random times from 1-30 minutes if there are any 5XX or 404 errors returned from the client/partner.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"id"**: string (UUID), **"time"**: string (RFC3339), **"source"**: string, **"subject"**: string (UUID), **"specversion"**: string, **"datacontenttype"**: string (IANA Media Types), **"dataschemaversion"**: string (majorversion.minorversion), **"externalsubjectid"**: string } & { **"data"**: object, **"type"**: string }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | Authorization error.  |
| 403 | Forbidden |
| 500 | Internal Server Error |
| 503 | Service Unavailable |
| 2XX | Callback successfully processed; no retries will be performed. |

#### Callback: consentStatusChanged

##### [POST] `{callbackURL}`
**Consent Status Changed Callback**

These are API calls initiated by the Visa Consent System to the Visa Partner’s backend servers.
+ The <code>callbackURL</code> is specified by the Visa partners during onboarding.
+ Invoked whenever a consent changes status.
+ There will be 2 retries with random times from 1-30 minutes if there are any 5XX or 404 errors returned from the client/partner.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"id"**: string (UUID), **"time"**: string (RFC3339), **"source"**: string, **"subject"**: string (UUID), **"specversion"**: string, **"datacontenttype"**: string (IANA Media Types), **"dataschemaversion"**: string (majorversion.minorversion), **"externalsubjectid"**: string } & { **"data"**: { **"message"**: string, **"newStatus"**: string, <br>**Available values:** "INITIATED", "ACTIVE", "REVOKED", "EXPIRED", "CONSUMED", "PAUSED", **"updatedBy"**: string, **"previousStatus"**: string, <br>**Available values:** "INITIATED", "ACTIVE", "REVOKED", "EXPIRED", "CONSUMED", "PAUSED" }, **"type"**: string }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | Authorization error.  |
| 403 | Forbidden |
| 500 | Internal Server Error |
| 503 | Service Unavailable |
| 2XX | Callback successfully processed; no retries will be performed. |

#### Callback: consentAttributeChanged

##### [POST] `{callbackURL}`
**Consent Attribute Changed Callback**

These are API calls initiated by the Visa Consent System to the Visa Partner’s backend servers.
+ The <code>callbackURL</code> is specified by the Visa partners during onboarding.
+ Invoked whenever one or more mutable consent attributes is changed. The if details of the new consent values are required, the message recipient must fetch the consent details using the GET /consents/{consentId} API.
+ There will be 2 retries with random times from 1-30 minutes if there are any 5XX or 404 errors returned from the client/partner.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"id"**: string (UUID), **"time"**: string (RFC3339), **"source"**: string, **"subject"**: string (UUID), **"specversion"**: string, **"datacontenttype"**: string (IANA Media Types), **"dataschemaversion"**: string (majorversion.minorversion), **"externalsubjectid"**: string } & { **"data"**: object, **"type"**: string }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | Authorization error.  |
| 403 | Forbidden |
| 500 | Internal Server Error |
| 503 | Service Unavailable |
| 2XX | Callback successfully processed; no retries will be performed. |

### [GET] /vcms/v1/consents/{consentID}
**Get Consent**

This API retrieves the consent object identified by consent ID.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| consentID | path | Consent identifier.  | Yes | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Get the consent object corresponding to consentID. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"status"**: string, <br>**Available values:** "INITIATED", "ACTIVE", "REVOKED", "EXPIRED", "CONSUMED", "PAUSED", **"userID"**: string, **"consentID"**: string (uuid) } & { **"frequency"**: string, <br>**Available values:** "STREAMING", "PERIODIC", "ON_DEMAND", "CONTEXT_BASED", <br>**Default:** STREAMING, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"primaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"externalConsentID"**: string, **"presentedLanguage"**: string (BCP-47), **"previousConsentID"**: string (uuid), **"secondaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"consentCaptureCity"**: string, **"consentDirectoryID"**: string (uuid), **"expirationDateTime"**: string (RFC3339), **"privacyPolicyVersion"**: string, **"consentCaptureCountry"**: string (ISO 3166-1 alpha 2), **"consentCaptureDateTime"**: string (RFC3339), **"presentedContentVersion"**: string, **"presenterOrganizationID"**: string (uuid), **"consentCaptureRegionState"**: string (ISO 3166-2 subdivision), **"resourceProviderOrganizationIDs"**: [ string (uuid) ] } & { **"constraints"**: { **"timespan"**: { **"endDateTime"**: string (RFC3339), **"startDateTime"**: string (RFC3339) }, **"maxNumberUses"**: integer, **"remainingNumberUses"**: integer }, **"createdDateTime"**: string (RFC3339), **"updatedDateTime"**: string (RFC3339), **"financialInstruments"**: [ { **"instrumentID"**: string (uuid), **"accountNumber"**: string, **"instrumentType"**: string, <br>**Available values:** "PAYMENT_CARD", "VCARDID", "BANK_ACCOUNT", "PAYMENT_TOKEN" } ], **"consumerContactInformation"**: { **"phoneNumber"**: string, **"emailAddress"**: string (Email Address), **"isPhoneNumberVerified"**: boolean, **"isEmailAddressVerified"**: boolean }, **"identityVerificationDetails"**: { **"userID"**: string, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"attestation"**: string, **"attestationType"**: string, <br>**Available values:** "ID_TOKEN" } }<br> |
| 400 | The <code>details</code> part of the error response can provide a list of fields that failed data validation constraints and reason values for this error include:   <ul>   <li><code>badRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that this Visa Developer Center project does not have permission to access the requested resource. This can happen if you are trying to invoke an API request for a resource that is not part of your project.  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 404 | The specified resource was not found<br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable. This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |

### [PATCH] /vcms/v1/consents/{consentID}
**Update Consent**

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| consentID | path | Consent identifier.  | Yes | string | No |

#### Request Body

Consent request body for PATCH Consent.

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"status"**: string, <br>**Available values:** "ACTIVE", "CONSUMED", "PAUSED", **"constraints"**: { **"remainingNumberUses"**: integer }, **"secondaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"financialInstruments"**: [ { **"instrumentID"**: string (uuid) } & { **"accountNumber"**: string, **"instrumentType"**: string, <br>**Available values:** "PAYMENT_CARD", "VCARDID", "BANK_ACCOUNT", "PAYMENT_TOKEN" } ], **"consumerContactInformation"**: { **"phoneNumber"**: string, **"emailAddress"**: string (Email Address), **"isPhoneNumberVerified"**: boolean, **"isEmailAddressVerified"**: boolean }, **"identityVerificationDetails"**: { **"userID"**: string, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"attestation"**: string, **"attestationType"**: string, <br>**Available values:** "ID_TOKEN", "THREED_SECURE" } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Update the consent object corresponding to consentID. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"status"**: string, <br>**Available values:** "INITIATED", "ACTIVE", "REVOKED", "EXPIRED", "CONSUMED", "PAUSED", **"userID"**: string, **"consentID"**: string (uuid) } & { **"frequency"**: string, <br>**Available values:** "STREAMING", "PERIODIC", "ON_DEMAND", "CONTEXT_BASED", <br>**Default:** STREAMING, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"primaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"externalConsentID"**: string, **"presentedLanguage"**: string (BCP-47), **"previousConsentID"**: string (uuid), **"secondaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"consentCaptureCity"**: string, **"consentDirectoryID"**: string (uuid), **"expirationDateTime"**: string (RFC3339), **"privacyPolicyVersion"**: string, **"consentCaptureCountry"**: string (ISO 3166-1 alpha 2), **"consentCaptureDateTime"**: string (RFC3339), **"presentedContentVersion"**: string, **"presenterOrganizationID"**: string (uuid), **"consentCaptureRegionState"**: string (ISO 3166-2 subdivision), **"resourceProviderOrganizationIDs"**: [ string (uuid) ] } & { **"constraints"**: { **"timespan"**: { **"endDateTime"**: string (RFC3339), **"startDateTime"**: string (RFC3339) }, **"maxNumberUses"**: integer, **"remainingNumberUses"**: integer }, **"createdDateTime"**: string (RFC3339), **"updatedDateTime"**: string (RFC3339), **"financialInstruments"**: [ { **"instrumentID"**: string (uuid), **"accountNumber"**: string, **"instrumentType"**: string, <br>**Available values:** "PAYMENT_CARD", "VCARDID", "BANK_ACCOUNT", "PAYMENT_TOKEN" } ], **"consumerContactInformation"**: { **"phoneNumber"**: string, **"emailAddress"**: string (Email Address), **"isPhoneNumberVerified"**: boolean, **"isEmailAddressVerified"**: boolean }, **"identityVerificationDetails"**: { **"userID"**: string, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"attestation"**: string, **"attestationType"**: string, <br>**Available values:** "ID_TOKEN" } }<br> |
| 400 | The <code>details</code> part of the error response can provide a list of fields that failed data validation constraints and reason values for this error include:   <ul>   <li><code>badRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that this Visa Developer Center project does not have permission to access the requested resource. This can happen if you are trying to invoke an API request for a resource that is not part of your project.  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 404 | The specified resource was not found<br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable. This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 409 | The current state of consent is incompatible with the requested mutation. For example, an EXPIRED consent cannot be revoked.</li> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |

### [POST] /vcms/v1/consents/{consentID}/validate
**Validate Consent**

This API is used by Resource Providers to verify that a consent is recorded against the provided user ID. If so, the consent object is returned.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| consentID | path | Consent identifier.  | Yes | string | No |

#### Request Body

Consent validate request body.

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"userID"**: string, **"identityVerificationDetails"**: { **"userID"**: string } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Consent response.<br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"status"**: string, <br>**Available values:** "INITIATED", "ACTIVE", "REVOKED", "EXPIRED", "CONSUMED", "PAUSED", **"userID"**: string, **"consentID"**: string (uuid) } & { **"frequency"**: string, <br>**Available values:** "STREAMING", "PERIODIC", "ON_DEMAND", "CONTEXT_BASED", <br>**Default:** STREAMING, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"primaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"externalConsentID"**: string, **"presentedLanguage"**: string (BCP-47), **"previousConsentID"**: string (uuid), **"secondaryPurposes"**: [ { **"purposeType"**: string, **"consentItemTypes"**: [ string ], **"beneficiaryOrganizationIDs"**: [ string (uuid) ] } ], **"consentCaptureCity"**: string, **"consentDirectoryID"**: string (uuid), **"expirationDateTime"**: string (RFC3339), **"privacyPolicyVersion"**: string, **"consentCaptureCountry"**: string (ISO 3166-1 alpha 2), **"consentCaptureDateTime"**: string (RFC3339), **"presentedContentVersion"**: string, **"presenterOrganizationID"**: string (uuid), **"consentCaptureRegionState"**: string (ISO 3166-2 subdivision), **"resourceProviderOrganizationIDs"**: [ string (uuid) ] } & { **"constraints"**: { **"timespan"**: { **"endDateTime"**: string (RFC3339), **"startDateTime"**: string (RFC3339) }, **"maxNumberUses"**: integer, **"remainingNumberUses"**: integer }, **"createdDateTime"**: string (RFC3339), **"updatedDateTime"**: string (RFC3339), **"financialInstruments"**: [ { **"instrumentID"**: string (uuid), **"accountNumber"**: string, **"instrumentType"**: string, <br>**Available values:** "PAYMENT_CARD", "VCARDID", "BANK_ACCOUNT", "PAYMENT_TOKEN" } ], **"consumerContactInformation"**: { **"phoneNumber"**: string, **"emailAddress"**: string (Email Address), **"isPhoneNumberVerified"**: boolean, **"isEmailAddressVerified"**: boolean }, **"identityVerificationDetails"**: { **"userID"**: string, **"userIDType"**: string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED", **"attestation"**: string, **"attestationType"**: string, <br>**Available values:** "ID_TOKEN" } }<br> |
| 400 | The <code>details</code> part of the error response can provide a list of fields that failed data validation constraints and reason values for this error include:   <ul>   <li><code>badRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that this Visa Developer Center project does not have permission to access the requested resource. This can happen if you are trying to invoke an API request for a resource that is not part of your project.  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 404 | The specified resource was not found<br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable. This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 422 | The server understands the content type of the request entity, and the syntax of the request entity is correct but was unable to process the contained instructions. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |

### [PUT] /vcms/v1/consents/{consentID}/status
**Update Consent Status**

API for Visa partners (Consent Requestors) to update consent status.
Notes:
Status may be set in accordance with the following state transitions, with invalid transitions resulting in a 409 error with <code>invalidConsentStateTransition</code> reason.
  + ACTIVE -> PAUSED
  + PAUSED -> ACTIVE
  + ACTIVE -> CONSUMED

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| X-Correlation-Id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| consentID | path | Consent identifier.  | Yes | string | No |

#### Request Body

Consent request body for PUT Consent Status.

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"status"**: string, <br>**Available values:** "ACTIVE", "CONSUMED", "PAUSED" }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Consent status updated successfully <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"status"**: string, <br>**Available values:** "ACTIVE", "CONSUMED", "PAUSED" }<br> |
| 400 | The <code>details</code> part of the error response can provide a list of fields that failed data validation constraints and reason values for this error include:   <ul>   <li><code>badRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that this Visa Developer Center project does not have permission to access the requested resource. This can happen if you are trying to invoke an API request for a resource that is not part of your project.  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 404 | The specified resource was not found<br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable. This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 409 | The current state of consent is incompatible with the requested mutation. For example, an EXPIRED consent cannot be revoked.</li> <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support at developer@visa.com if you want to increase the time limits. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 500 | Internal Server Error.  Please contact Visa Support at developer@visa.com with a complete error message, full http request and response details. <br>**Headers:**<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support at developer@visa.com if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**X-Correlation-Id**: Unique ID for the API response; <code>X-Correlation-Id</code> is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"message"**:  }<br>**application/problem+json**: { **"type"**: string (uri-reference), <br>**Default:** about:blank, **"title"**: string, **"detail"**: string, **"status"**: integer, **"instance"**: string (uri-reference) }<br> |

---
### Schemas

#### ConsentConstraintsForCreation Schema

Additional consent constraints.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| timespan | { **"endDateTime"**: string (RFC3339), **"startDateTime"**: string (RFC3339) } | A timespan constraint applicable for the consent item types captured in the consent. For example, consent for historical transaction data may have a constraint to include only transactions from the last 6 months. That constraint would be captured here. Not applicable to consents with <code>STREAMING</code> frequency.  | No |
| maxNumberUses | integer | The maximum number of uses for the consent item types captured in the consent. Not applicable to consents with <code>STREAMING</code> frequency.  | No |

#### StandardError Schema

API errors are reported using a Standard Error Response structure. All errors are categorized into Standard errors and Business errors. Standard errors can be returned by any API and should be handled in a common way. Business errors are returned only by some APIs and are documented for each API.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| StandardError | { **"reason"**: string, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } | API errors are reported using a Standard Error Response structure. All errors are categorized into Standard errors and Business errors. Standard errors can be returned by any API and should be handled in a common way. Business errors are returned only by some APIs and are documented for each API. |  |

#### UserIdentifierType Schema

The type of the provided user identifier (userID).

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| UserIdentifierType | string, <br>**Available values:** "EMAIL_ADDRESS", "PHONE_NUMBER", "VCARDID", "PAN", "CLIENT_DEFINED" | The type of the provided user identifier (userID).  |  |

**Example**
<pre>EMAIL_ADDRESS</pre>

#### ConsentType Schema

The type of the consent describes the use cases applicable for the consent.
<code>CARD_TRANSACTION_EVENTS</code> applies to card transaction data subscription (using webhooks/callback model), and <code>CARD_TRANSACTION_DATA</code> applies to card transaction history data (using REST API request/response model). 
There will be other consent types applicable in the future like PAYMENTS, etc.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| ConsentType | string, <br>**Available values:** "CARD_TRANSACTION_DATA", "CARD_TRANSACTION_EVENTS" | The type of the consent describes the use cases applicable for the consent. <code>CARD_TRANSACTION_EVENTS</code> applies to card transaction data subscription (using webhooks/callback model), and <code>CARD_TRANSACTION_DATA</code> applies to card transaction history data (using REST API request/response model).  There will be other consent types applicable in the future like PAYMENTS, etc.  |  |

#### ConsumerContactInformation Schema

Contact information for the end consumer.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| phoneNumber | string | Phone number, which may include only numerical digits. <br>*Example:* `"15555555555"` | No |
| emailAddress | string (Email Address) | Email address. <br>*Example:* `"consumer@visa.com"` | No |
| isPhoneNumberVerified | boolean | Indicates whether the phone number has been verified by the caller.  | No |
| isEmailAddressVerified | boolean | Indicates whether the email address has been verified by the caller.  | No |

#### CloudEventEnvelopeSchema Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| id | string (UUID) | Unique identifier for the message. <br>*Example:* `"b0ea6631-cb51-fa2b-f426-150b5757e201"` | No |
| time | string (RFC3339) | Datetime when the message was generated. <br>*Example:* `"2021-04-05T17:31:00Z"` | No |
| source | string | Source of the message. <br>*Example:* `"https://visa.com"` | No |
| subject | string (UUID) | Consent identifier. <br>*Example:* `"01-a8023ee6-64a1-4c48-b1c8-7609faf41f1f"` | No |
| specversion | string | Version of the message envelope schema. <br>*Example:* `"1.0"` | No |
| datacontenttype | string (IANA Media Types) | Format of the message under the "data" object. <br>*Example:* `"application/json"` | No |
| dataschemaversion | string (majorversion.minorversion) | Extension attribute which provides a version for the schema defined in the "data" element.  Increments within a single major version indicate that backward compatibility is preserved. <br>*Example:* `"1.0"` | No |
| externalsubjectid | string | Client-provided consent identifier, which was optionally supplied at consent creation in "externalConsentID". <br>*Example:* `"clientdefinedidentifier123"` | No |

#### ConsentValidateRequest Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| userID | string | The identifier of the user for whom the consent is created. The type of this identifier is defined by the value of the corresponding userIDType attribute.  User identifiers of type <code>EMAIL_ADDRESS</code> <code>PHONE_NUMBER</code> <code>PAN</code> and <code>CLIENT_DEFINED</code> are not retained as-is in the consent system, and will be returned as masked values in subsequent API responses. <br>*Example:* `"consumer@visa.com"` | Yes |
| identityVerificationDetails | { **"userID"**: string } |  | No |

#### AuthenticationMethod Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| AuthenticationMethod | string, <br>**Available values:** "CARDHOLDER_AUTH_BY_ISSUER", "VERIFIED_BY_VISA" |  |  |

#### ConsentDirectoryIdentifier Schema

[...]
